<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        $sql = <<<'SQL'
            CREATE TABLE production_plans (
                id					BIGINT GENERATED always AS IDENTITY PRIMARY KEY,

                line_id			    BIGINT NOT NULL,
                shift_id			BIGINT NOT NULL,
                plant_id			BIGINT NOT NULL,

                plan_quantity		INT NOT NULL CHECK (plan_quantity > 0),
                production_quantity	INT NOT NULL DEFAULT (0),

                created_at			TIMESTAMP NOT NULL DEFAULT NOW(),
                updated_at			TIMESTAMP NOT NULL DEFAULT NOW(),
                deleted_at			TIMESTAMP,

                FOREIGN KEY (line_id) REFERENCES lines (id),
                FOREIGN KEY (shift_id) REFERENCES shifts (id),
                FOREIGN KEY (plant_id) REFERENCES plants (id)
            );
        SQL;

        DB::statement($sql);
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('production_plans');
    }
};
